
	CHAR_MASK		=	FREE_D9		; byte usado para fazer AND no texto para compatibilidade com Apple][ sem letra minuscula
	IS_APPLE2		=	FREE_1E
	HTAB		=	$24
	VTAB		=	$25

	PRINT_DATA	=	FREE_EE
	CHKSUM		= 	UNK_I_FE
	
	PREAD		=	$FB1E
	VERSION		=	$FBB3
	
SYSTEM_INIT:
	lda		#$ff
	sta		CHAR_MASK
	sta		IS_APPLE2

	lda		VERSION
	cmp		#$38				; Apple II / II+
	beq		@lowcase_capable
	cmp		#$98				; TK-2000 (MPF-II)
	beq		@tk2000
	cmp		#$EA
	bne		@lowcase_capable
	lda		PREAD
	cmp		#$AD
	bne		@lowcase_capable
	
@tk2000:
	lda		#0
	sta		IS_APPLE2
	
@upcase_only:
	lda		#$DF
	sta		CHAR_MASK
	
@lowcase_capable:
	jsr		MON_SETKBD
	jsr		MON_SETVID
	
	bit		IS_APPLE2
	beq		:+
	jsr		MON_INIT
	jmp		MON_HOME	
:	; Para o TK-2000
	lda		TK2K_HW_TEXTBW
	jsr		TK2K_MON_INIT1
	jmp		MON_HOME
	
PRINT_TEXT:
	sta		PRINT_DATA
	sty		PRINT_DATA+1
	ldy		#0
	sty		CHKSUM
:
	jsr		@_get
	bmi		@exit
	sta		VTAB
	jsr		@_get
	sta		HTAB
	
	jsr		@print

	clc
	bcc		:-

@print:
	jsr		@_get
	beq		@eol
	
	bit		IS_APPLE2
	beq		:+
	pha
	lda		VTAB
	jsr		MON_BASCALC
	pla	
:	
	jsr		PRINT_CHAR
	
	clc
	bcc		@print
@exit:
	lda		CHKSUM
@eol:
	rts

@_get:
	lda 	(PRINT_DATA),y
	php
	iny
	pha
	eor		CHKSUM
	sta		CHKSUM
	pla
	plp
	rts

PRINT_ASCII:
	ora		#$80
PRINT_CHAR:
	cmp		#$61|$80
	bcc		:+
	and		CHAR_MASK
:	
	jmp		MON_COUT

SYSTEM_TEXT:
	bit		IS_APPLE2
	beq		:+
	jmp		APPLESOFT_CMD_TEXT
:	jmp		TK2K_APPLESOFT_CMD_TEXT

SYSTEM_HGR:
	bit		IS_APPLE2
	beq		:+
	jmp		APPLESOFT_CMD_HGR
:	jmp		TK2K_APPLESOFT_CMD_HGR	

SYSTEM_APPLESOFT_START_COLD:
	bit		IS_APPLE2
	beq		:+
	jmp		APPLESOFT_START_COLD
:	jmp		TK2K_APPLESOFT_START_COLD	
